package org.jboss.as.quickstart.hibernate4.data;

import java.util.List;

import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.metamodel.EntityType;
import javax.persistence.metamodel.Metamodel;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Order;
import org.jboss.as.quickstart.hibernate4.model.Member;

@javax.inject.Named
@javax.ejb.Singleton
public class SecondaryMemberRepository extends BaseDAO {

	private EntityManager em;

	@Override
	@javax.persistence.PersistenceContext(unitName = "secondary")
	public void setEm(EntityManager em) {

		System.out.println("Called setEM on SecondaryMemberRepository, PU would set to Secondary! But the EM really is -> EntityManager["+new com.google.gson.Gson().toJson(em)+"]");
		new RuntimeException().printStackTrace();
		Metamodel mm = em.getMetamodel();
		for (EntityType<?> entity : mm.getEntities()) {
			System.out.println("I have the " + entity.getName() +" entity mapped, is that right?\n\n\n");
		}
		this.em = em;
	}

	public Member findById(Long id) {
		return em.find(Member.class, id);
	}

	@SuppressWarnings("unchecked")
	public List<Member> findAllOrderedByName() {
		// using Hibernate Session and Criteria Query via Hibernate Native API
		Session session = (Session) em.getDelegate();
		Criteria cb = session.createCriteria(Member.class);
		cb.addOrder(Order.asc("name"));
		return (List<Member>) cb.list();
		// return members;
	}
}
